# encoding: UTF-8

require 'digest/md5'
require 'builder'

module OnPayRuClient
  VERSION = '0.1.0'

  class Client
    attr_reader :login, :key, :url, :success_url, :fail_url

    def initialize(login, key, url, success_url, fail_url)
      @login = login
      @key = key
      @url = url
      @success_url = success_url
      @fail_url = fail_url
    end

    def check(type, pay_for, amount, order_currency, code)
      md5 = Digest::MD5.hexdigest(
        type.to_s + ";" + pay_for.to_s + ";" + amount.to_s + ";" +
        order_currency.to_s + ";" + code.to_s + ";" + @key.to_s
      ).upcase

      query = String.new
      xml = Builder::XmlMarkup.new(:target => query)

      xml.result {
        xml.code code.to_s
        xml.pay_for pay_for.to_s
        xml.comment "OK"
        xml.md5 md5.to_s
      }

      return query
    end

    def check_md5(type, pay_for, amount, order_currency)
      md5 = Digest::MD5.hexdigest(
        type.to_s + ";" + pay_for.to_s + ";" + amount.to_s + ";" +
        order_currency.to_s + ";" + @key.to_s
      ).upcase
    end

    def pay(type, pay_for, onpay_id, order_id, amount, order_currency, code)
      md5 = Digest::MD5.hexdigest(
        type.to_s + ";" + pay_for.to_s + ";" + onpay_id.to_s + ";" +
        order_id.to_s + ";" + amount.to_s + ";" + order_currency.to_s + ";" +
        code.to_s + ";" + @key.to_s
      ).upcase

      query = String.new
      xml = Builder::XmlMarkup.new(:target => query)

      xml.result {
        xml.code code.to_s
        xml.comment "OK"
        xml.onpay_id onpay_id.to_s
        xml.pay_for pay_for.to_s
        xml.order_id order_id.to_s
        xml.md5 md5.to_s
      }

      return query
    end

    def pay_md5(type, pay_for, onpay_id, amount, order_currency)
      md5 = Digest::MD5.hexdigest(
        type.to_s + ";" + pay_for.to_s + ";" + onpay_id.to_s + ";" +
        amount.to_s + ";" + order_currency.to_s + ";" + @key.to_s
      ).upcase
    end

    def get_url(pay_for, amount, email)
      return "http://secure.onpay.ru/pay/#{@login}?pay_mode=fix&price=#{amount.to_s}&pay_for=#{pay_for.to_s}&user_email=#{email}&url_success=#{@success_url}&url_fail=#{@fail_url}"
    end
  end
end
